<template>
  <div id="order">
    <br>
    <h2 v-show="getAggrItems.length > 0">КОРЗИНА</h2>
    <table id="order-items" v-show="getAggrItems.length > 0">
      <app-order-item :key="item.orderKey" v-for="item in getAggrItems" :item="item"/>
      <tr class="total">
        <td class="name">ИТОГО:</td>
        <td></td>
        <td class="price">{{getOrderSum}} ₽</td>
      </tr>
    </table>
    <app-contact-form id="order-form" :withComment="true" :titleText="'КОНТАКТ'"/>
    <br>
    <app-pay-form/>
    <br>
    <app-delivery-form/>
    <button
      v-show="getAggrItems.length > 0"
      id="send-order"
      @click="onSend"
      v-scroll-to="{el: '#order-form', offset: shortOffset}"
    >ЗАКАЗАТЬ ПИЦЦУ</button>
    <!-- <h3 v-else class="thank">Спасибо. Ваш заказ отправлен!</h3> -->
    <br>
    <br>
    <transition name="thanks">
      <div id="thanks-form-back" v-show="getThanksWindow" @click="hide">
        <div id="thanks-form" @click="hide">{{thanksMessage}}</div>
      </div>
    </transition>
  </div>
</template>
<script>
import OrderItem from "./OrderItem";
import ContactForm from "./ContactForm";
import { mapGetters, mapMutations, mapActions } from "vuex";
import DeliveryForm from "./DeliveryForm.vue";
import PayForm from "./PayForm";
export default {
  components: {
    "app-order-item": OrderItem,
    "app-contact-form": ContactForm,
    "app-delivery-form": DeliveryForm,
    "app-pay-form": PayForm
  },
  data() {
    return {
      loading: false,
      shortOffset: -50,
      longOffset: -200
    };
  },
  methods: {
    hide() {
      if (!this.loading) this.$store.commit("hideThanksWindow");
    },
    ...mapMutations(["showThanksWindow", "hideThanksWindow", "reset"]),
    onSend(event) {
      this.$store.commit("formValidation");
      if (this.$store.state.validToOrder) {
        console.log("valid form");
        this.$store.dispatch("fetchLatLng").then(() => {
          this.$store
            .dispatch("sendOrder")
            .then(() => {
              console.log("Answered " + Date.now());
              this.loading = false;
              this.reset();
            })
            .catch(e => {
              this.loading = false;
            });
          this.loading = true;
          console.log("Start send " + Date.now());
          this.showThanksWindow();
        });
      }
    }
  },
  computed: {
    ...mapGetters([
      "getAggrItems",
      "getOrderSum",
      "isOrderSent",
      "getThanksWindow"
    ]),
    thanksMessage() {
      if (this.loading) return "Обработка запроса, пожалуйста подождите...";
      if (this.$store.state.callRequire)
        return "СПАСИБО ЗА ВАШ ЗАКАЗ! СКОРО МЫ СВЯЖЕМСЯ С ВАМИ!";
      if (this.$store.state.deliveryType == 2)
        return "СПАСИБО ЗА ВАШ ЗАКАЗ!  ЖДЁМ ВАС В ГОСТИ!";
      return "СПАСИБО ЗА ВАШ ЗАКАЗ!  СКОРО МЫ ДОСТАВИМ ВАМ ГОРЯЧУЮ ПИЦЦУ!";
    }
  }
};
</script>
<style scoped>
h2 {
  text-align: left;
}
#order {
  width: 100%;
  max-width: 840px;
  padding: 10px;
}
#order-items {
  margin-top: 20px;
  margin-bottom: 40px;
  width: 100%;
}
#send-order {
  border: none;
  display: block;
  border-radius: 10px;
  background-color: #f0712c;
  color: white;
  width: 300px;
  padding: 15px;
  margin-right: 10px;
  margin-top: 20px;
  transition: all 0.1s ease;
}
#send-order:hover {
  background-color: #de601b;
}
.thank {
  color: green;
  padding: 10px;
}

.total td.price {
  font-size: 1.3em;
  text-align: right;
  padding-right: 5px;
}
.total td.name {
  font-size: 1.3em;
  text-align: left;
  padding-top: 20px;
  padding-bottom: 20px;
}
#thanks-form-back {
  position: fixed;
  top: 0;
  left: 0;
  width: 100vw;
  height: 100vh;
  background-color: #00000055;
  display: flex;
  justify-content: center;
  align-items: center;
  z-index: 10;
}
#thanks-form {
  display: block;
  flex: 1;
  max-width: 700px;
  min-width: 300px;
  padding: 50px;
  background-color: white;
  border: 1px solid #ddd;
  font-size: 1.5em;
  text-align: center;
  line-height: 1.5em;
}
.thanks-enter-active,
.thanks-leave-active {
  transition: opacity 0.1s;
}
.thanks-enter,
.thanks-leave-to {
  opacity: 0;
}
</style>